SuperLU: SRC/dutil.c File Reference

# SRC/dutil.c File Reference

Matrix utility functions. More...

`#include <math.h>`
`#include "slu_ddefs.h"`

## Functions
void | dCreate_CompCol_Matrix (SuperMatrix *A, int m, int n, int nnz, double *nzval, int *rowind, int *colptr, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
| Supernodal LU factor related.
void | dCreate_CompRow_Matrix (SuperMatrix *A, int m, int n, int nnz, double *nzval, int *colind, int *rowptr, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | dCopy_CompCol_Matrix (SuperMatrix *A, SuperMatrix *B)
| Copy matrix A into matrix B.
void | dCreate_Dense_Matrix (SuperMatrix *X, int m, int n, double *x, int ldx, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | dCopy_Dense_Matrix (int M, int N, double *X, int ldx, double *Y, int ldy)
void | dCreate_SuperNode_Matrix (SuperMatrix *L, int m, int n, int nnz, double *nzval, int *nzval_colptr, int *rowind, int *rowind_colptr, int *col_to_sup, int *sup_to_col, Stype_t stype, Dtype_t dtype, Mtype_t mtype)
void | dCompRow_to_CompCol (int m, int n, int nnz, double *a, int *colind, int *rowptr, double **at, int **rowind, int **colptr)
| Convert a row compressed storage into a column compressed storage.
void | dPrint_CompCol_Matrix (char *what, SuperMatrix *A)
| Routines for debugging.
void | dPrint_SuperNode_Matrix (char *what, SuperMatrix *A)
void | dPrint_Dense_Matrix (char *what, SuperMatrix *A)
void | dprint_lu_col (char *msg, int jcol, int pivrow, int *xprune, GlobalLU_t *Glu)
| Diagnostic print of column "jcol" in the U/L factor.
void | dcheck_tempv (int n, double *tempv)
| Check whether tempv[] == 0. This should be true before and after calling any numeric routines, i.e., "panel_bmod" and "column_bmod".
void | dGenXtrue (int n, int nrhs, double *x, int ldx)
void | dFillRHS (trans_t trans, int nrhs, double *x, int ldx, SuperMatrix *A, SuperMatrix *B)
| Let rhs[i] = sum of i-th row of A, so the solution vector is all 1's.
void | dfill (double *a, int alen, double dval)
| Fills a double precision array with a given value.
void | dinf_norm_error (int nrhs, SuperMatrix *X, double *xtrue)
| Check the inf-norm of the error vector.
void | dPrintPerf (SuperMatrix *L, SuperMatrix *U, mem_usage_t *mem_usage, double rpg, double rcond, double *ferr, double *berr, char *equed, SuperLUStat_t *stat)
| Print performance of the code.
| print_double_vec (char *what, int n, double *vec)

## Detailed Description

     -- SuperLU routine (version 3.1) --
     Univ. of California Berkeley, Xerox Palo Alto Research Center,
     and Lawrence Berkeley National Lab.
     August 1, 2008

     Copyright (c) 1994 by Xerox Corporation.  All rights reserved.

     THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY
     EXPRESSED OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.

     Permission is hereby granted to use or copy this program for any
     purpose, provided the above notices are retained on all copies.
     Permission to modify the code and to distribute modified code is
     granted, provided the above notices are retained, and a notice that
     the code was modified is included with the above copyright notice.

## Function Documentation

void dcheck_tempv | ( | int | n,
|  | double * | tempv |
| ) |  |  |

void dCompRow_to_CompCol | ( | int | m,
|  | int | n,
|  | int | nnz,
|  | double * | a,
|  | int * | colind,
|  | int * | rowptr,
|  | double ** | at,
|  | int ** | rowind,
|  | int ** | colptr |
| ) |  |  |

void dCopy_CompCol_Matrix | ( | SuperMatrix * | A,
|  | SuperMatrix * | B |
| ) |  |  |

void dCopy_Dense_Matrix | ( | int | M,
|  | int | N,
|  | double * | X,
|  | int | ldx,
|  | double * | Y,
|  | int | ldy |
| ) |  |  |

Copies a two-dimensional matrix X to another matrix Y.

void dCreate_CompCol_Matrix | ( | SuperMatrix * | A,
|  | int | m,
|  | int | n,
|  | int | nnz,
|  | double * | nzval,
|  | int * | rowind,
|  | int * | colptr,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype |
| ) |  |  |

void dCreate_CompRow_Matrix | ( | SuperMatrix * | A,
|  | int | m,
|  | int | n,
|  | int | nnz,
|  | double * | nzval,
|  | int * | colind,
|  | int * | rowptr,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype |
| ) |  |  |

void dCreate_Dense_Matrix | ( | SuperMatrix * | X,
|  | int | m,
|  | int | n,
|  | double * | x,
|  | int | ldx,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype |
| ) |  |  |

void dCreate_SuperNode_Matrix | ( | SuperMatrix * | L,
|  | int | m,
|  | int | n,
|  | int | nnz,
|  | double * | nzval,
|  | int * | nzval_colptr,
|  | int * | rowind,
|  | int * | rowind_colptr,
|  | int * | col_to_sup,
|  | int * | sup_to_col,
|  | Stype_t | stype,
|  | Dtype_t | dtype,
|  | Mtype_t | mtype |
| ) |  |  |

void dfill | ( | double * | a,
|  | int | alen,
|  | double | dval |
| ) |  |  |

void dFillRHS | ( | trans_t | trans,
|  | int | nrhs,
|  | double * | x,
|  | int | ldx,
|  | SuperMatrix * | A,
|  | SuperMatrix * | B |
| ) |  |  |

void dGenXtrue | ( | int | n,
|  | int | nrhs,
|  | double * | x,
|  | int | ldx |
| ) |  |  |

void dinf_norm_error | ( | int | nrhs,
|  | SuperMatrix * | X,
|  | double * | xtrue |
| ) |  |  |

void dPrint_CompCol_Matrix | ( | char * | what,
|  | SuperMatrix * | A |
| ) |  |  |

void dPrint_Dense_Matrix | ( | char * | what,
|  | SuperMatrix * | A |
| ) |  |  |

void dprint_lu_col | ( | char * | msg,
|  | int | jcol,
|  | int | pivrow,
|  | int * | xprune,
|  | GlobalLU_t * | Glu |
| ) |  |  |

void dPrint_SuperNode_Matrix | ( | char * | what,
|  | SuperMatrix * | A |
| ) |  |  |

void dPrintPerf | ( | SuperMatrix * | L,
|  | SuperMatrix * | U,
|  | mem_usage_t * | mem_usage,
|  | double | rpg,
|  | double | rcond,
|  | double * | ferr,
|  | double * | berr,
|  | char * | equed,
|  | SuperLUStat_t * | stat |
| ) |  |  |

print_double_vec | ( | char * | what,
|  | int | n,
|  | double * | vec |
| ) |  |  |